/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the FlowOperationFormatRules type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &FlowOperationFormatRules{}

// FlowOperationFormatRules struct for FlowOperationFormatRules
type FlowOperationFormatRules struct {
	// Column ID
	Column *string `json:"column,omitempty"`
	// If used will be used instead of column (eg. *, all_dates)
	ColumnWildcard *string `json:"column_wildcard,omitempty"`
	// Formatting function to be used (eg: timestamp_to_string)
	Function *string `json:"function,omitempty"`
	// Style format to which the real value will be formatted to
	Format *string `json:"format,omitempty"`
}

// NewFlowOperationFormatRules instantiates a new FlowOperationFormatRules object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewFlowOperationFormatRules() *FlowOperationFormatRules {
	this := FlowOperationFormatRules{}
	return &this
}

// NewFlowOperationFormatRulesWithDefaults instantiates a new FlowOperationFormatRules object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewFlowOperationFormatRulesWithDefaults() *FlowOperationFormatRules {
	this := FlowOperationFormatRules{}
	return &this
}

// GetColumn returns the Column field value if set, zero value otherwise.
func (o *FlowOperationFormatRules) GetColumn() string {
	if o == nil || IsNil(o.Column) {
		var ret string
		return ret
	}
	return *o.Column
}

// GetColumnOk returns a tuple with the Column field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *FlowOperationFormatRules) GetColumnOk() (*string, bool) {
	if o == nil || IsNil(o.Column) {
		return nil, false
	}
	return o.Column, true
}

// HasColumn returns a boolean if a field has been set.
func (o *FlowOperationFormatRules) HasColumn() bool {
	if o != nil && !IsNil(o.Column) {
		return true
	}

	return false
}

// SetColumn gets a reference to the given string and assigns it to the Column field.
func (o *FlowOperationFormatRules) SetColumn(v string) {
	o.Column = &v
}

// GetColumnWildcard returns the ColumnWildcard field value if set, zero value otherwise.
func (o *FlowOperationFormatRules) GetColumnWildcard() string {
	if o == nil || IsNil(o.ColumnWildcard) {
		var ret string
		return ret
	}
	return *o.ColumnWildcard
}

// GetColumnWildcardOk returns a tuple with the ColumnWildcard field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *FlowOperationFormatRules) GetColumnWildcardOk() (*string, bool) {
	if o == nil || IsNil(o.ColumnWildcard) {
		return nil, false
	}
	return o.ColumnWildcard, true
}

// HasColumnWildcard returns a boolean if a field has been set.
func (o *FlowOperationFormatRules) HasColumnWildcard() bool {
	if o != nil && !IsNil(o.ColumnWildcard) {
		return true
	}

	return false
}

// SetColumnWildcard gets a reference to the given string and assigns it to the ColumnWildcard field.
func (o *FlowOperationFormatRules) SetColumnWildcard(v string) {
	o.ColumnWildcard = &v
}

// GetFunction returns the Function field value if set, zero value otherwise.
func (o *FlowOperationFormatRules) GetFunction() string {
	if o == nil || IsNil(o.Function) {
		var ret string
		return ret
	}
	return *o.Function
}

// GetFunctionOk returns a tuple with the Function field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *FlowOperationFormatRules) GetFunctionOk() (*string, bool) {
	if o == nil || IsNil(o.Function) {
		return nil, false
	}
	return o.Function, true
}

// HasFunction returns a boolean if a field has been set.
func (o *FlowOperationFormatRules) HasFunction() bool {
	if o != nil && !IsNil(o.Function) {
		return true
	}

	return false
}

// SetFunction gets a reference to the given string and assigns it to the Function field.
func (o *FlowOperationFormatRules) SetFunction(v string) {
	o.Function = &v
}

// GetFormat returns the Format field value if set, zero value otherwise.
func (o *FlowOperationFormatRules) GetFormat() string {
	if o == nil || IsNil(o.Format) {
		var ret string
		return ret
	}
	return *o.Format
}

// GetFormatOk returns a tuple with the Format field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *FlowOperationFormatRules) GetFormatOk() (*string, bool) {
	if o == nil || IsNil(o.Format) {
		return nil, false
	}
	return o.Format, true
}

// HasFormat returns a boolean if a field has been set.
func (o *FlowOperationFormatRules) HasFormat() bool {
	if o != nil && !IsNil(o.Format) {
		return true
	}

	return false
}

// SetFormat gets a reference to the given string and assigns it to the Format field.
func (o *FlowOperationFormatRules) SetFormat(v string) {
	o.Format = &v
}

func (o FlowOperationFormatRules) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o FlowOperationFormatRules) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Column) {
		toSerialize["column"] = o.Column
	}
	if !IsNil(o.ColumnWildcard) {
		toSerialize["column_wildcard"] = o.ColumnWildcard
	}
	if !IsNil(o.Function) {
		toSerialize["function"] = o.Function
	}
	if !IsNil(o.Format) {
		toSerialize["format"] = o.Format
	}
	return toSerialize, nil
}

type NullableFlowOperationFormatRules struct {
	value *FlowOperationFormatRules
	isSet bool
}

func (v NullableFlowOperationFormatRules) Get() *FlowOperationFormatRules {
	return v.value
}

func (v *NullableFlowOperationFormatRules) Set(val *FlowOperationFormatRules) {
	v.value = val
	v.isSet = true
}

func (v NullableFlowOperationFormatRules) IsSet() bool {
	return v.isSet
}

func (v *NullableFlowOperationFormatRules) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableFlowOperationFormatRules(val *FlowOperationFormatRules) *NullableFlowOperationFormatRules {
	return &NullableFlowOperationFormatRules{value: val, isSet: true}
}

func (v NullableFlowOperationFormatRules) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableFlowOperationFormatRules) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
